{STARTOVNI CISLO 12}
unit Mian;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    ODMapa: TOpenDialog;
    Panel1: TPanel;
    Button1: TButton;
    MMapa: TMemo;
    Img_Map: TImage;
    MPath: TMemo;
    BSave: TButton;
    BFind: TButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    BEnd: TButton;
    label8: TLabel;
    LSX: TLabel;
    LSY: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    LWidth: TLabel;
    LHeight: TLabel;
    SaveDialog1: TSaveDialog;
    Label11: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure MapToArray;
    procedure ShowMap;
    procedure FindPath;
    procedure FindNext(x,y,speedx,speedy, level: integer);
    function isOK(x,y,level: integer): byte;
    procedure BFindClick(Sender: TObject);
    procedure BEndClick(Sender: TObject);
    procedure BSaveClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
const MAX = 255;

var
  Form1: TForm1;
  mapa: array of array of byte;//pruchozi a nepruchozi pole.
  Start: TPoint;
  Cil: TPoint;
  map_w, map_h: integer;
  dist: array of array of integer;//vzdalenosti od startu

implementation

{$R *.dfm}
{STARTOVNI CISLO 12}
{JAK BY MEL ALGORITMUS VE VYSLEDKU VYPADAT...
(a jak asi nevypada...)
Z kazdeho pole vyzkousim vsechny moznosti, kam se muzu dostat pri ruznych zmenach rychlosti.
Pomoci rekurze to tak delam u kazdeho pole, kam se dostanu. Rekurzi volam jen pro ta pole, kam
jsem zatim nenasel kratsi cestu. Kdyz nabouram, volam rekurzi pro nulovou rychlost v obou smerech,
jinak volam rekurze se zmenenou rychlosti, podle toho, jak jsem se na pole dostal. Bohuzel to asi
neni optimalni algoritmus a tak mi pada s chybou stack overflow.

Cestu pak hledam od cile zpatky pomoci backtrackingu. Pak uz ji jen vypisu.

Hledani "nejbezpecnejsi cesty" by probihalo v podstate stejne, ale hledal bych v podstate jen na
polich oznacenych ':'. 
}

//Tato funkce kontroluje, zda se da na dane policko jet
function TForm1.isOK(x,y,level: integer): byte;
begin
//vyjeti z obrazovky
  if x < 0 then
  begin
    result:=0;
    exit;
  end;
  if y < 0 then
  begin
    result:=0;
    exit;
  end;
  if x > map_w-1 then
  begin
    result:=0;
    exit;
  end;
  if y > map_h-1 then
  begin
    result:=0;
    exit;
  end;
//nabourani
  if (mapa[x][y] = 0) then
  begin
    result:=0;
    exit;        
  end;

//prijeti na volne pole, nebo do cile
  if ((dist[x][y] = -1)or(dist[x][y]>level))then
  begin
    if mapa[x][y] = 4 then
    begin
      Cil.X:=x;
      Cil.Y:=y;
      result:=2;
    end;
    result:=1;
  end
  else result:=3;
end;

//najde policka kam se da dostat z policka, kde prave je
{V teto (rekurzivni)funkci se program vzdy zasekne, protoze auto porad boura na jednom miste
a nemuze se pohnout. rekurze porad kontroluje to same, to uz jsem ale nestihl dodelat...}
procedure TForm1.FindNext(x,y,speedx,speedy,level: integer);
var
  i: integer;
begin
//x+1 , y+1
  i:=isOK(x+speedx+1,y+speedy+1,level+1);
  case i of
    0: FindNext(x,y,0,0,level+1);
    1: FindNext(x+speedx+1,y+speedy+1,speedx+1, speedy+1, level+1);
    2: exit;
    3: exit;
  end;
//x+1 , y
  i:=isOK(x+speedx+1,y+speedy,level+1);
  case i of
    0: FindNext(x,y,0,0,level+1);
    1: FindNext(x+speedx+1,y,speedx+1, speedy, level+1);
    2: exit;
    3: exit;
  end;
//x+1 , y-1
  i:=isOK(x+speedx+1,y+speedy-1,level+1);
  case i of
    0: FindNext(x,y,0,0,level+1);
    1: FindNext(x+speedx+1,y+speedy-1,speedx+1, speedy-1, level+1);
    2: exit;
    3: exit;
  end;
//x   , y+1
  i:=isOK(x+speedx,y+speedy+1,level+1);
  case i of
    0: FindNext(x,y,0,0,level+1);
    1: FindNext(x+speedx,y+speedy+1,speedx, speedy+1, level+1);
    2: exit;
    3: exit;
  end;
//x   , y-1
  i:=isOK(x+speedx,y+speedy-1,level+1);
  case i of
    0: FindNext(x,y,0,0,level+1);
    1: FindNext(x+speedx,y+speedy-1,speedx, speedy-1, level+1);
    2: exit;
    3: exit;
  end;
//x-1 , y+1
  i:=isOK(x+speedx-1,y+speedy+1,level+1);
  case i of
    0: FindNext(x,y,0,0,level+1);
    1: FindNext(x+speedx-1,y+speedy+1,speedx-1, speedy+1, level+1);
    2: exit;
    3: exit;
  end;
//x-1 , y
  i:=isOK(x+speedx-1,y+speedy,level+1);
  case i of
    0: FindNext(x,y,0,0,level+1);
    1: FindNext(x+speedx-1,y+speedy,speedx-1, speedy, level+1);
    2: exit;
    3: exit;
  end;
//x-1 , y-1
  i:=isOK(x+speedx-1,y+speedy-1,level+1);
  case i of
    0: FindNext(x,y,0,0,level+1);
    1: FindNext(x+speedx-1,y+speedy-1,speedx-1, speedy-1, level+1);
    2: exit;
    3: exit;
  end;
end;

procedure TForm1.FindPath;
var
  x,y: integer;
begin
  Finalize(dist);
  SetLength(dist, map_w, map_h);
  for x:= 0 to map_w-1 do
  begin
    for y:=0 to map_h-1 do
    begin
      dist[x][y] := -1;
    end;
  end;
  FindNext(Start.X,Start.Y,0,0,0);
  if dist[cil.x][cil.Y] > -1 then ShowMessage('BINGO');
end;

procedure TForm1.ShowMap;
var
  x,y: integer;
  draw_width, draw_height: integer;
begin
//Zobrazi mapu
  draw_width := Img_Map.Width div map_w;
  draw_height := Img_Map.Height div map_h;
//  ShowMessage(IntToStr(draw_width)+','+IntToStr(draw_height));
  Img_Map.Canvas.Brush.Color:=clBlack;
  Img_Map.Canvas.FillRect(Rect(0,0,400,400));
  for x:=0 to map_w-1 do
  begin
    for y:=0 to map_h-1 do
    begin
      case mapa[x][y] of
        0:Img_Map.Canvas.Brush.Color:=clBlack;//neprujezdne
        1:Img_Map.Canvas.Brush.Color:=clAqua;//start
        2:Img_Map.Canvas.Brush.Color:=clLime;//bezpecna cesta
        3:Img_Map.Canvas.Brush.Color:=clGreen;//cesta
        4:Img_Map.Canvas.Brush.Color:=clFuchsia;//cil
      end;
      Img_Map.Canvas.FillRect(Rect(x*draw_width,y*draw_height,x*draw_width+draw_width,y*draw_width+draw_height));
    end;
  end;
end;
//tato funkce ulozi mapu z mema do pole
procedure TForm1.MapToArray;
var
  w,
  h: integer;
  x,y: byte;
  radek: String;
begin
//mapu nactenou v memu hodi do pole.
  w := Length(MMapa.Lines[0]);
  h := MMapa.Lines.Count;
  map_w := w;
  map_h := h;
  ShowMessage('sirka: '+IntToStr(map_w)+', vyska: '+IntToStr(map_h));
  LWidth.Caption:=IntToStr(map_w);
  LHeight.Caption:=IntToStr(map_h);
  Finalize(mapa);
  SetLength(mapa, w, h);
  //ukladani jednotlivych znaku do pole cisel.
  for y:=0 to h-1 do
  begin
    radek:=MMapa.Lines[y];
    for x:=0 to w-1 do
    begin
      case radek[x-1] of
        'X':mapa[x][y]:=0;
        'S':begin
          Start.X:=x;
          Start.Y:=y;
          LSX.Caption := 'x: '+intToStr(x);
          LSY.Caption := 'y: '+IntToStr(map_h - y -1);
          mapa[x][y]:=1;
        end;
        ':':mapa[x][y]:=2;
        '.':mapa[x][y]:=3;
        'C':mapa[x][y]:=4;
      end;
    end;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
//  Nacte mapu do MMapa.
  if ODMapa.Execute then
  begin
    MMapa.Lines.Clear;
    MMapa.Lines.LoadFromFile(ODMapa.FileName);
    MapToArray;
    ShowMap;
  end;
end;

procedure TForm1.BFindClick(Sender: TObject);
var
  i: integer;
begin
  FindPath;
  MPath.Lines.Clear;
  randomize;
  i:=random(3);
  case i of
  0: MPath.Lines.Add('doleva, pak doprava a pak do cile...');
  1: MPath.Lines.Add('nejkratsi cestou rovnou do cile!');
  2:begin
    MPath.Lines.Add('hledam...');
    MPath.Lines.Add('asi nenajdu, ale muzete to zkouset...');    
  end;
  end;
end;

procedure TForm1.BEndClick(Sender: TObject);
begin
Application.Terminate;
end;

procedure TForm1.BSaveClick(Sender: TObject);
begin
  if SaveDialog1.Execute then
  begin
    MPath.Lines.SaveToFile(SaveDialog1.FileName);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
	Img_Map.Canvas.Brush.Color:=clBlack;
	Img_Map.Canvas.FillRect(Rect(0,0,0,0));
end;

end.
{STARTOVNI CISLO 12}
